unit u_imgform;

{$IFDEF FPC}
{$mode objfpc}{$H+}
{$R *.lfm}
{$ELSE}
{$R *.dfm}
{$ENDIF}

interface

uses
  Classes, SysUtils, db, Forms,
  {$IFDEF FPC}
  LazFileUtils,
  {$ENDIF}
  Controls, Graphics, Dialogs, ExtCtrls,
  U_OnFormInfoIni, u_extdbgrid,
  U_ExtImages, u_buttons_appli,
  IBDatabase, IBCustomDataSet, IBUpdateSQL,
  IBQuery;

type

  { TFormImages }

  TFormImages = class(TForm)
    ExtImages: TExtImages;
    FWDelete1: TFWDelete;
    IBDatabase: TIBDatabase;
    Panel1: TPanel;
    Counting: TPanel;
    procedure ExtDBGrid1KeyPress(Sender: TObject; var Key: char);
    procedure ExtImagesImagesAdd(Sender: TObject);
    procedure ExtNumEditAAEnter(Sender: TObject);
    procedure ExtNumEditAAExit(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FWDelete1Click(Sender: TObject);
    procedure IBDatabaseBeforeConnect(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  FormImages: TFormImages;

implementation

uses fonctions_dbcomponents,
     fonctions_dialogs,
     fonctions_system;

{ TFormImages }

procedure TFormImages.FormCreate(Sender: TObject);
begin
  (*
  {$IFNDEF FPC}
  IBDatabase.Params.Add('lc_ctype=LATIN1');
  {$ENDIF}
  try
    IBDatabase.Connected := True;
    IBTransaction.Active := True;
    {$IFNDEF FPC}
    IBNumbers.UpdateObject:=IBUpdateSQL;
    {$ENDIF}
    // On cherche ou crée le fichier CSV
    IBNumbers.Open;
    //(TNumericField(IBNumbers.FieldByName('Number'))).DisplayFormat:='#0,99';
  Except
    // Il s'agit d'une entrée/sortie donc on gère les exceptions
    on e:Exception do
      Begin
       ShowMessage ( 'Impossible d''ouvrir la connexion : ' + E.Message );
       Exit;
      end;
  end;*)
end;

procedure TFormImages.FWDelete1Click(Sender: TObject);
begin
  if MyMessageDlg('Confirm','Do you really want to erase every memos ?',mtConfirmation,mbYesNo,0,FormImages)=mrYes Then
    ExtImages.EraseMemos;
end;

procedure TFormImages.ExtNumEditAAExit(Sender: TObject);
begin
{  if IBNumbers.State in [dsinsert,dsedit] then
    IBNumbers.Post;}
end;

procedure TFormImages.ExtDBGrid1KeyPress(Sender: TObject; var Key: char);
begin
{  if IBNumbers.Active
  and ( Key = '-' ) Then
   IBNumbers.Delete;}
end;

procedure TFormImages.ExtImagesImagesAdd(Sender: TObject);
begin
  Counting.Caption:='Counter : ' + IntToStr ( ExtImages.Columns.Counter );
end;

procedure TFormImages.ExtNumEditAAEnter(Sender: TObject);
begin
{  if IBNumbers.Active then
    IBNumbers.Edit;}
end;


procedure TFormImages.IBDatabaseBeforeConnect(Sender: TObject);
var lstl_conf : TStringList;
begin
{  IBDatabase.DatabaseName:=gs_DefaultDatabase;
  try
    lstl_conf := TStringList.Create;
    lstl_conf.Text := 'RootDirectory='+ExtractSubDir(getAppDir);
    lstl_conf.SaveToFile(ExtractFileDir(Application.ExeName)+DirectorySeparator+'Numeric.conf');
  finally
    lstl_conf.Free;
  end;
 }
end;

end.

